Index: /branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/LIM_SRC_3/icedyn_adv_pra.F90
===================================================================
--- /branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/LIM_SRC_3/icedyn_adv_pra.F90	(revision 8816)
+++ /branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/LIM_SRC_3/icedyn_adv_pra.F90	(revision 8817)
@@ -652,376 +660,175 @@
       CHARACTER(len=25) ::   znam
       CHARACTER(len=2)  ::   zchar, zchar1
-      REAL(wp), DIMENSION(jpi,jpj) :: z2d
+      REAL(wp), DIMENSION(jpi,jpj,jpl) ::   z3d   ! 3D workspace
       !!----------------------------------------------------------------------
       !
-      IF( TRIM(cdrw) == 'READ' ) THEN        ! Read/initialize
-         !                                   ! ---------------
-         IF( ln_rstart ) THEN                   !* Read the restart file
-            !
-            id1 = iom_varid( numrir, 'sxopw' , ldstop = .FALSE. )
-            !
-            IF( id1 > 0 ) THEN      ! fields exist
-               DO jl = 1, jpl 
-                  WRITE(zchar,'(I2.2)') jl
-                  znam = 'sxice'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sxice(:,:,jl) = z2d(:,:)
-                  znam = 'syice'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  syice(:,:,jl) = z2d(:,:)
-                  znam = 'sxxice'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sxxice(:,:,jl) = z2d(:,:)
-                  znam = 'syyice'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  syyice(:,:,jl) = z2d(:,:)
-                  znam = 'sxyice'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sxyice(:,:,jl) = z2d(:,:)
-                  znam = 'sxsn'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sxsn(:,:,jl) = z2d(:,:)
-                  znam = 'sysn'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sysn(:,:,jl) = z2d(:,:)
-                  znam = 'sxxsn'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sxxsn(:,:,jl) = z2d(:,:)
-                  znam = 'syysn'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  syysn(:,:,jl) = z2d(:,:)
-                  znam = 'sxysn'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sxysn(:,:,jl) = z2d(:,:)
-                  znam = 'sxa'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sxa(:,:,jl) = z2d(:,:)
-                  znam = 'sya'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sya(:,:,jl) = z2d(:,:)
-                  znam = 'sxxa'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sxxa(:,:,jl) = z2d(:,:)
-                  znam = 'syya'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  syya(:,:,jl) = z2d(:,:)
-                  znam = 'sxya'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sxya(:,:,jl) = z2d(:,:)
-                  znam = 'sxc0'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sxc0(:,:,jl) = z2d(:,:)
-                  znam = 'syc0'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  syc0(:,:,jl) = z2d(:,:)
-                  znam = 'sxxc0'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sxxc0(:,:,jl) = z2d(:,:)
-                  znam = 'syyc0'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  syyc0(:,:,jl) = z2d(:,:)
-                  znam = 'sxyc0'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sxyc0(:,:,jl) = z2d(:,:)
-                  znam = 'sxsal'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sxsal(:,:,jl) = z2d(:,:)
-                  znam = 'sysal'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sysal(:,:,jl) = z2d(:,:)
-                  znam = 'sxxsal'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sxxsal(:,:,jl) = z2d(:,:)
-                  znam = 'syysal'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  syysal(:,:,jl) = z2d(:,:)
-                  znam = 'sxysal'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sxysal(:,:,jl) = z2d(:,:)
-                  znam = 'sxage'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sxage(:,:,jl) = z2d(:,:)
-                  znam = 'syage'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  syage(:,:,jl) = z2d(:,:)
-                  znam = 'sxxage'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sxxage(:,:,jl) = z2d(:,:)
-                  znam = 'syyage'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  syyage(:,:,jl) = z2d(:,:)
-                  znam = 'sxyage'//'_htc'//zchar
-                  CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                  sxyage(:,:,jl)= z2d(:,:)
-               END DO
-               IF ( ln_pnd_H12 ) THEN
-                  DO jl = 1, jpl 
-                     WRITE(zchar,'(I2.2)') jl
-                     znam = 'sxap'//'_htc'//zchar
-                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                     sxap(:,:,jl) = z2d(:,:)
-                     znam = 'syap'//'_htc'//zchar
-                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                     syap(:,:,jl) = z2d(:,:)
-                     znam = 'sxxap'//'_htc'//zchar
-                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                     sxxap(:,:,jl) = z2d(:,:)
-                     znam = 'syyap'//'_htc'//zchar
-                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                     syyap(:,:,jl) = z2d(:,:)
-                     znam = 'sxyap'//'_htc'//zchar
-                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                     sxyap(:,:,jl) = z2d(:,:)
-
-                     znam = 'sxvp'//'_htc'//zchar
-                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                     sxvp(:,:,jl) = z2d(:,:)
-                     znam = 'syvp'//'_htc'//zchar
-                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                     syvp(:,:,jl) = z2d(:,:)
-                     znam = 'sxxvp'//'_htc'//zchar
-                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                     sxxvp(:,:,jl) = z2d(:,:)
-                     znam = 'syyvp'//'_htc'//zchar
-                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                     syyvp(:,:,jl) = z2d(:,:)
-                     znam = 'sxyvp'//'_htc'//zchar
-                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                     sxyvp(:,:,jl) = z2d(:,:)
-                  END DO
-               ENDIF
-
-               CALL iom_get( numrir, jpdom_autoglo, 'sxopw ' ,  sxopw  )
-               CALL iom_get( numrir, jpdom_autoglo, 'syopw ' ,  syopw  )
-               CALL iom_get( numrir, jpdom_autoglo, 'sxxopw' ,  sxxopw )
-               CALL iom_get( numrir, jpdom_autoglo, 'syyopw' ,  syyopw )
-               CALL iom_get( numrir, jpdom_autoglo, 'sxyopw' ,  sxyopw )
-
-               DO jl = 1, jpl 
-                  WRITE(zchar,'(I2.2)') jl
-                  DO jk = 1, nlay_i 
-                     WRITE(zchar1,'(I2.2)') jk
-                     znam = 'sxe'//'_il'//zchar1//'_htc'//zchar
-                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                     sxe(:,:,jk,jl) = z2d(:,:)
-                     znam = 'sye'//'_il'//zchar1//'_htc'//zchar
-                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                     sye(:,:,jk,jl) = z2d(:,:)
-                     znam = 'sxxe'//'_il'//zchar1//'_htc'//zchar
-                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                     sxxe(:,:,jk,jl) = z2d(:,:)
-                     znam = 'syye'//'_il'//zchar1//'_htc'//zchar
-                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                     syye(:,:,jk,jl) = z2d(:,:)
-                     znam = 'sxye'//'_il'//zchar1//'_htc'//zchar
-                     CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
-                     sxye(:,:,jk,jl) = z2d(:,:)
-                  END DO
-               END DO
-               !
-            ELSE                                     ! start rheology from rest
-               IF(lwp) WRITE(numout,*) '   ==>>   previous run without Prather, set moments to 0'
-               sxopw (:,:) = 0._wp   ;   sxice (:,:,:) = 0._wp   ;   sxsn (:,:,:)  = 0._wp   ;   sxa  (:,:,:) = 0._wp
-               syopw (:,:) = 0._wp   ;   syice (:,:,:) = 0._wp   ;   sysn (:,:,:)  = 0._wp   ;   sya  (:,:,:) = 0._wp
-               sxxopw(:,:) = 0._wp   ;   sxxice(:,:,:) = 0._wp   ;   sxxsn(:,:,:)  = 0._wp   ;   sxxa (:,:,:) = 0._wp
-               syyopw(:,:) = 0._wp   ;   syyice(:,:,:) = 0._wp   ;   syysn(:,:,:)  = 0._wp   ;   syya (:,:,:) = 0._wp
-               sxyopw(:,:) = 0._wp   ;   sxyice(:,:,:) = 0._wp   ;   sxysn(:,:,:)  = 0._wp   ;   sxya (:,:,:) = 0._wp
-               !
-               sxc0  (:,:,:) = 0._wp   ;   sxe  (:,:,:,:) = 0._wp   ;   sxsal  (:,:,:) = 0._wp   ;   sxage  (:,:,:) = 0._wp
-               syc0  (:,:,:) = 0._wp   ;   sye  (:,:,:,:) = 0._wp   ;   sysal  (:,:,:) = 0._wp   ;   syage  (:,:,:) = 0._wp
-               sxxc0 (:,:,:) = 0._wp   ;   sxxe (:,:,:,:) = 0._wp   ;   sxxsal (:,:,:) = 0._wp   ;   sxxage (:,:,:) = 0._wp
-               syyc0 (:,:,:) = 0._wp   ;   syye (:,:,:,:) = 0._wp   ;   syysal (:,:,:) = 0._wp   ;   syyage (:,:,:) = 0._wp
-               sxyc0 (:,:,:) = 0._wp   ;   sxye (:,:,:,:) = 0._wp   ;   sxysal (:,:,:) = 0._wp   ;   sxyage (:,:,:) = 0._wp
-               IF ( ln_pnd_H12 ) THEN
-                  sxap  (:,:,:) = 0._wp    ; sxvp  (:,:,:) = 0._wp 
-                  syap  (:,:,:) = 0._wp    ; syvp  (:,:,:) = 0._wp 
-                  sxxap (:,:,:) = 0._wp    ; sxxvp (:,:,:) = 0._wp 
-                  syyap (:,:,:) = 0._wp    ; syyvp (:,:,:) = 0._wp 
-                  sxyap (:,:,:) = 0._wp    ; sxyvp (:,:,:) = 0._wp
-               ENDIF
+      !                                      !==========================!
+      IF( TRIM(cdrw) == 'READ' ) THEN        !==  Read or initialize  ==!
+         !                                   !==========================!
+         !
+         IF( ln_rstart ) THEN   ;   id1 = iom_varid( numrir, 'sxopw' , ldstop = .FALSE. )    ! file exist: id1>0
+         ELSE                   ;   id1 = 0                                                  ! no restart: id1=0
+         ENDIF
+         !
+         IF( id1 > 0 ) THEN                     !**  Read the restart file  **!
+            !
+            !                                                        ! ice thickness
+            CALL iom_get( numrir, jpdom_autoglo, 'sxice' , sxice  )
+            CALL iom_get( numrir, jpdom_autoglo, 'syice' , syice  )
+            CALL iom_get( numrir, jpdom_autoglo, 'sxxice', sxxice )
+            CALL iom_get( numrir, jpdom_autoglo, 'syyice', syyice )
+            CALL iom_get( numrir, jpdom_autoglo, 'sxyice', sxyice )
+            !                                                        ! snow thickness
+            CALL iom_get( numrir, jpdom_autoglo, 'sxsn'  , sxsn   )
+            CALL iom_get( numrir, jpdom_autoglo, 'sysn'  , sysn   )
+            CALL iom_get( numrir, jpdom_autoglo, 'sxxsn' , sxxsn  )
+            CALL iom_get( numrir, jpdom_autoglo, 'syysn' , syysn  )
+            CALL iom_get( numrir, jpdom_autoglo, 'sxysn' , sxysn  )
+            !                                                        ! lead fraction
+            CALL iom_get( numrir, jpdom_autoglo, 'sxa'   , sxa    )
+            CALL iom_get( numrir, jpdom_autoglo, 'sya'   , sya    )
+            CALL iom_get( numrir, jpdom_autoglo, 'sxxa'  , sxxa   )
+            CALL iom_get( numrir, jpdom_autoglo, 'syya'  , syya   )
+            CALL iom_get( numrir, jpdom_autoglo, 'sxya'  , sxya   )
+            !                                                        ! snow thermal content
+            CALL iom_get( numrir, jpdom_autoglo, 'sxc0'  , sxc0   )
+            CALL iom_get( numrir, jpdom_autoglo, 'syc0'  , syc0   )
+            CALL iom_get( numrir, jpdom_autoglo, 'sxxc0' , sxxc0  )
+            CALL iom_get( numrir, jpdom_autoglo, 'syyc0' , syyc0  )
+            CALL iom_get( numrir, jpdom_autoglo, 'sxyc0' , sxyc0  )
+            !                                                        ! ice salinity
+            CALL iom_get( numrir, jpdom_autoglo, 'sxsal' , sxsal  )
+            CALL iom_get( numrir, jpdom_autoglo, 'sysal' , sysal  )
+            CALL iom_get( numrir, jpdom_autoglo, 'sxxsal', sxxsal )
+            CALL iom_get( numrir, jpdom_autoglo, 'syysal', syysal )
+            CALL iom_get( numrir, jpdom_autoglo, 'sxysal', sxysal )
+            !                                                        ! ice age
+            CALL iom_get( numrir, jpdom_autoglo, 'sxage' , sxage  )
+            CALL iom_get( numrir, jpdom_autoglo, 'syage' , syage  )
+            CALL iom_get( numrir, jpdom_autoglo, 'sxxage', sxxage )
+            CALL iom_get( numrir, jpdom_autoglo, 'syyage', syyage )
+            CALL iom_get( numrir, jpdom_autoglo, 'sxyage', sxyage )
+            !                                                        ! open water in sea ice
+            CALL iom_get( numrir, jpdom_autoglo, 'sxopw ', sxopw  )
+            CALL iom_get( numrir, jpdom_autoglo, 'syopw ', syopw  )
+            CALL iom_get( numrir, jpdom_autoglo, 'sxxopw', sxxopw )
+            CALL iom_get( numrir, jpdom_autoglo, 'syyopw', syyopw )
+            CALL iom_get( numrir, jpdom_autoglo, 'sxyopw', sxyopw )
+            !                                                        ! ice layers heat content
+            DO jk = 1, nlay_i 
+               WRITE(zchar1,'(I2.2)') jk
+               znam = 'sxe'//'_il'//zchar1   ;   CALL iom_get( numrir, jpdom_autoglo, znam , z3d )   ;   sxe (:,:,jk,:) = z3d(:,:,:)
+               znam = 'sye'//'_il'//zchar1   ;   CALL iom_get( numrir, jpdom_autoglo, znam , z3d )   ;   sye (:,:,jk,:) = z3d(:,:,:)
+               znam = 'sxxe'//'_il'//zchar1  ;   CALL iom_get( numrir, jpdom_autoglo, znam , z3d )   ;   sxxe(:,:,jk,:) = z3d(:,:,:)
+               znam = 'syye'//'_il'//zchar1  ;   CALL iom_get( numrir, jpdom_autoglo, znam , z3d )   ;   syye(:,:,jk,:) = z3d(:,:,:)
+               znam = 'sxye'//'_il'//zchar1  ;   CALL iom_get( numrir, jpdom_autoglo, znam , z3d )   ;   sxye(:,:,jk,:) = z3d(:,:,:)
+            END DO
+            !
+            IF( ln_pnd_H12 ) THEN                                    ! melt pond fraction
+               CALL iom_get( numrir, jpdom_autoglo, 'sxap' , sxap  )
+               CALL iom_get( numrir, jpdom_autoglo, 'syap' , syap  )
+               CALL iom_get( numrir, jpdom_autoglo, 'sxxap', sxxap )
+               CALL iom_get( numrir, jpdom_autoglo, 'syyap', syyap )
+               CALL iom_get( numrir, jpdom_autoglo, 'sxyap', sxyap )
+               !                                                     ! melt pond volume
+               CALL iom_get( numrir, jpdom_autoglo, 'sxvp' , sxvp  )
+               CALL iom_get( numrir, jpdom_autoglo, 'syvp' , syvp  )
+               CALL iom_get( numrir, jpdom_autoglo, 'sxxvp', sxxvp )
+               CALL iom_get( numrir, jpdom_autoglo, 'syyvp', syyvp )
+               CALL iom_get( numrir, jpdom_autoglo, 'sxyvp', sxyvp )
             ENDIF
-         ELSE                                   !* Start from rest
-            IF(lwp) WRITE(numout,*) '   ==>>   start from rest: set moments to 0'
-            sxopw (:,:) = 0._wp   ;   sxice (:,:,:) = 0._wp   ;   sxsn (:,:,:)  = 0._wp   ;   sxa  (:,:,:) = 0._wp
-            syopw (:,:) = 0._wp   ;   syice (:,:,:) = 0._wp   ;   sysn (:,:,:)  = 0._wp   ;   sya  (:,:,:) = 0._wp
-            sxxopw(:,:) = 0._wp   ;   sxxice(:,:,:) = 0._wp   ;   sxxsn(:,:,:)  = 0._wp   ;   sxxa (:,:,:) = 0._wp
-            syyopw(:,:) = 0._wp   ;   syyice(:,:,:) = 0._wp   ;   syysn(:,:,:)  = 0._wp   ;   syya (:,:,:) = 0._wp
-            sxyopw(:,:) = 0._wp   ;   sxyice(:,:,:) = 0._wp   ;   sxysn(:,:,:)  = 0._wp   ;   sxya (:,:,:) = 0._wp
-            !
-            sxc0  (:,:,:) = 0._wp   ;   sxe  (:,:,:,:) = 0._wp   ;   sxsal  (:,:,:) = 0._wp   ;   sxage  (:,:,:) = 0._wp
-            syc0  (:,:,:) = 0._wp   ;   sye  (:,:,:,:) = 0._wp   ;   sysal  (:,:,:) = 0._wp   ;   syage  (:,:,:) = 0._wp
-            sxxc0 (:,:,:) = 0._wp   ;   sxxe (:,:,:,:) = 0._wp   ;   sxxsal (:,:,:) = 0._wp   ;   sxxage (:,:,:) = 0._wp
-            syyc0 (:,:,:) = 0._wp   ;   syye (:,:,:,:) = 0._wp   ;   syysal (:,:,:) = 0._wp   ;   syyage (:,:,:) = 0._wp
-            sxyc0 (:,:,:) = 0._wp   ;   sxye (:,:,:,:) = 0._wp   ;   sxysal (:,:,:) = 0._wp   ;   sxyage (:,:,:) = 0._wp
-            IF ( ln_pnd_H12 ) THEN
-               sxap  (:,:,:) = 0._wp    ; sxvp  (:,:,:) = 0._wp 
-               syap  (:,:,:) = 0._wp    ; syvp  (:,:,:) = 0._wp 
-               sxxap (:,:,:) = 0._wp    ; sxxvp (:,:,:) = 0._wp 
-               syyap (:,:,:) = 0._wp    ; syyvp (:,:,:) = 0._wp 
-               sxyap (:,:,:) = 0._wp    ; sxyvp (:,:,:) = 0._wp
+            !
+         ELSE                                   !**  start rheology from rest  **!
+            !
+            IF(lwp) WRITE(numout,*) '   ==>>   start from rest OR previous run without Prather, set moments to 0'
+            !
+            sxice = 0._wp   ;   syice = 0._wp   ;   sxxice = 0._wp   ;   syyice = 0._wp   ;   sxyice = 0._wp      ! ice thickness
+            sxsn  = 0._wp   ;   sysn  = 0._wp   ;   sxxsn  = 0._wp   ;   syysn  = 0._wp   ;   sxysn  = 0._wp      ! snow thickness
+            sxa   = 0._wp   ;   sya   = 0._wp   ;   sxxa   = 0._wp   ;   syya   = 0._wp   ;   sxya   = 0._wp      ! lead fraction
+            sxc0  = 0._wp   ;   syc0  = 0._wp   ;   sxxc0  = 0._wp   ;   syyc0  = 0._wp   ;   sxyc0  = 0._wp      ! snow thermal content
+            sxsal = 0._wp   ;   sysal = 0._wp   ;   sxxsal = 0._wp   ;   syysal = 0._wp   ;   sxysal = 0._wp      ! ice salinity
+            sxage = 0._wp   ;   syage = 0._wp   ;   sxxage = 0._wp   ;   syyage = 0._wp   ;   sxyage = 0._wp      ! ice age
+            sxopw = 0._wp   ;   syopw = 0._wp   ;   sxxopw = 0._wp   ;   syyopw = 0._wp   ;   sxyopw = 0._wp      ! open water in sea ice
+            sxe   = 0._wp   ;   sye   = 0._wp   ;   sxxe   = 0._wp   ;   syye   = 0._wp   ;   sxye   = 0._wp      ! ice layers heat content
+            IF( ln_pnd_H12 ) THEN
+               sxap  = 0._wp   ;   syap  = 0._wp   ;   sxxap  = 0._wp   ;   syyap  = 0._wp   ;   sxyap  = 0._wp   ! melt pond fraction
+               sxvp  = 0._wp   ;   syvp  = 0._wp   ;   sxxvp  = 0._wp   ;   syyvp  = 0._wp   ;   sxyvp  = 0._wp   ! melt pond volume
             ENDIF
          ENDIF
          !
-      ELSEIF( TRIM(cdrw) == 'WRITE' ) THEN   ! Create restart file
-         !                                   ! -------------------
-         IF(lwp) WRITE(numout,*) '---- adv-rst ----'
+         !                                   !=====================================!
+      ELSEIF( TRIM(cdrw) == 'WRITE' ) THEN   !==  write in the ice restart file  ==!
+         !                                   !=====================================!
+         IF(lwp) WRITE(numout,*) '----  ice-adv-rst  ----'
          iter = kt + nn_fsbc - 1             ! ice restarts are written at kt == nitrst - nn_fsbc + 1
          !
-         DO jl = 1, jpl 
-            WRITE(zchar,'(I2.2)') jl
-            znam = 'sxice'//'_htc'//zchar
-            z2d(:,:) = sxice(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'syice'//'_htc'//zchar
-            z2d(:,:) = syice(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'sxxice'//'_htc'//zchar
-            z2d(:,:) = sxxice(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'syyice'//'_htc'//zchar
-            z2d(:,:) = syyice(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'sxyice'//'_htc'//zchar
-            z2d(:,:) = sxyice(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'sxsn'//'_htc'//zchar
-            z2d(:,:) = sxsn(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'sysn'//'_htc'//zchar
-            z2d(:,:) = sysn(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'sxxsn'//'_htc'//zchar
-            z2d(:,:) = sxxsn(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'syysn'//'_htc'//zchar
-            z2d(:,:) = syysn(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'sxysn'//'_htc'//zchar
-            z2d(:,:) = sxysn(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'sxa'//'_htc'//zchar
-            z2d(:,:) = sxa(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'sya'//'_htc'//zchar
-            z2d(:,:) = sya(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'sxxa'//'_htc'//zchar
-            z2d(:,:) = sxxa(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'syya'//'_htc'//zchar
-            z2d(:,:) = syya(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'sxya'//'_htc'//zchar
-            z2d(:,:) = sxya(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'sxc0'//'_htc'//zchar
-            z2d(:,:) = sxc0(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'syc0'//'_htc'//zchar
-            z2d(:,:) = syc0(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'sxxc0'//'_htc'//zchar
-            z2d(:,:) = sxxc0(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'syyc0'//'_htc'//zchar
-            z2d(:,:) = syyc0(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'sxyc0'//'_htc'//zchar
-            z2d(:,:) = sxyc0(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'sxsal'//'_htc'//zchar
-            z2d(:,:) = sxsal(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'sysal'//'_htc'//zchar
-            z2d(:,:) = sysal(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'sxxsal'//'_htc'//zchar
-            z2d(:,:) = sxxsal(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'syysal'//'_htc'//zchar
-            z2d(:,:) = syysal(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'sxysal'//'_htc'//zchar
-            z2d(:,:) = sxysal(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'sxage'//'_htc'//zchar
-            z2d(:,:) = sxage(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'syage'//'_htc'//zchar
-            z2d(:,:) = syage(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'sxxage'//'_htc'//zchar
-            z2d(:,:) = sxxage(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'syyage'//'_htc'//zchar
-            z2d(:,:) = syyage(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            znam = 'sxyage'//'_htc'//zchar
-            z2d(:,:) = sxyage(:,:,jl)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-         END DO
-
-         CALL iom_rstput( iter, nitrst, numriw, 'sxopw ' ,  sxopw  )
-         CALL iom_rstput( iter, nitrst, numriw, 'syopw ' ,  syopw  )
-         CALL iom_rstput( iter, nitrst, numriw, 'sxxopw' ,  sxxopw )
-         CALL iom_rstput( iter, nitrst, numriw, 'syyopw' ,  syyopw )
-         CALL iom_rstput( iter, nitrst, numriw, 'sxyopw' ,  sxyopw )
-         
-         DO jl = 1, jpl 
-            WRITE(zchar,'(I2.2)') jl
-            DO jk = 1, nlay_i 
-               WRITE(zchar1,'(I2.2)') jk
-               znam = 'sxe'//'_il'//zchar1//'_htc'//zchar
-               z2d(:,:) = sxe(:,:,jk,jl)
-               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-               znam = 'sye'//'_il'//zchar1//'_htc'//zchar
-               z2d(:,:) = sye(:,:,jk,jl)
-               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-               znam = 'sxxe'//'_il'//zchar1//'_htc'//zchar
-               z2d(:,:) = sxxe(:,:,jk,jl)
-               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-               znam = 'syye'//'_il'//zchar1//'_htc'//zchar
-               z2d(:,:) = syye(:,:,jk,jl)
-               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-               znam = 'sxye'//'_il'//zchar1//'_htc'//zchar
-               z2d(:,:) = sxye(:,:,jk,jl)
-               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            END DO
-         END DO
-         IF ( ln_pnd_H12 ) THEN
-            DO jl = 1, jpl 
-               WRITE(zchar,'(I2.2)') jl
-               znam = 'sxap'//'_htc'//zchar
-               z2d(:,:) = sxap(:,:,jl)
-               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-               znam = 'syap'//'_htc'//zchar
-               z2d(:,:) = syap(:,:,jl)
-               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-               znam = 'sxxap'//'_htc'//zchar
-               z2d(:,:) = sxxap(:,:,jl)
-               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-               znam = 'syyap'//'_htc'//zchar
-               z2d(:,:) = syyap(:,:,jl)
-               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-               znam = 'sxyap'//'_htc'//zchar
-               z2d(:,:) = sxyap(:,:,jl)
-               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-   
-               znam = 'sxvp'//'_htc'//zchar
-               z2d(:,:) = sxvp(:,:,jl)
-               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-               znam = 'syvp'//'_htc'//zchar
-               z2d(:,:) = syvp(:,:,jl)
-               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-               znam = 'sxxvp'//'_htc'//zchar
-               z2d(:,:) = sxxvp(:,:,jl)
-               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-               znam = 'syyvp'//'_htc'//zchar
-               z2d(:,:) = syyvp(:,:,jl)
-               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-               znam = 'sxyvp'//'_htc'//zchar
-               z2d(:,:) = sxyvp(:,:,jl)
-               CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
-            END DO
+         !
+         ! In case Prather scheme is used for advection, write second order moments
+         ! ------------------------------------------------------------------------
+         !
+         !                                                           ! ice thickness
+         CALL iom_rstput( iter, nitrst, numriw, 'sxice' , sxice  )
+         CALL iom_rstput( iter, nitrst, numriw, 'syice' , syice  )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxxice', sxxice )
+         CALL iom_rstput( iter, nitrst, numriw, 'syyice', syyice )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxyice', sxyice )
+         !                                                           ! snow thickness
+         CALL iom_rstput( iter, nitrst, numriw, 'sxsn'  , sxsn   )
+         CALL iom_rstput( iter, nitrst, numriw, 'sysn'  , sysn   )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxxsn' , sxxsn  )
+         CALL iom_rstput( iter, nitrst, numriw, 'syysn' , syysn  )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxysn' , sxysn  )
+         !                                                           ! lead fraction
+         CALL iom_rstput( iter, nitrst, numriw, 'sxa'   , sxa    )
+         CALL iom_rstput( iter, nitrst, numriw, 'sya'   , sya    )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxxa'  , sxxa   )
+         CALL iom_rstput( iter, nitrst, numriw, 'syya'  , syya   )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxya'  , sxya   )
+         !                                                           ! snow thermal content
+         CALL iom_rstput( iter, nitrst, numriw, 'sxc0'  , sxc0   )
+         CALL iom_rstput( iter, nitrst, numriw, 'syc0'  , syc0   )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxxc0' , sxxc0  )
+         CALL iom_rstput( iter, nitrst, numriw, 'syyc0' , syyc0  )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxyc0' , sxyc0  )
+         !                                                           ! ice salinity
+         CALL iom_rstput( iter, nitrst, numriw, 'sxsal' , sxsal  )
+         CALL iom_rstput( iter, nitrst, numriw, 'sysal' , sysal  )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxxsal', sxxsal )
+         CALL iom_rstput( iter, nitrst, numriw, 'syysal', syysal )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxysal', sxysal )
+         !                                                           ! ice age
+         CALL iom_rstput( iter, nitrst, numriw, 'sxage' , sxage  )
+         CALL iom_rstput( iter, nitrst, numriw, 'syage' , syage  )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxxage', sxxage )
+         CALL iom_rstput( iter, nitrst, numriw, 'syyage', syyage )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxyage', sxyage )
+         !                                                           ! open water in sea ice
+         CALL iom_rstput( iter, nitrst, numriw, 'sxopw ', sxopw  )
+         CALL iom_rstput( iter, nitrst, numriw, 'syopw ', syopw  )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxxopw', sxxopw )
+         CALL iom_rstput( iter, nitrst, numriw, 'syyopw', syyopw )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxyopw', sxyopw )
+         !                                                           ! ice layers heat content
+         DO jk = 1, nlay_i 
+            WRITE(zchar1,'(I2.2)') jk
+            znam = 'sxe'//'_il'//zchar1   ;   z3d(:,:,:) = sxe (:,:,jk,:)   ;   CALL iom_rstput( iter, nitrst, numriw, znam , z3d )
+            znam = 'sye'//'_il'//zchar1   ;   z3d(:,:,:) = sye (:,:,jk,:)   ;   CALL iom_rstput( iter, nitrst, numriw, znam , z3d )
+            znam = 'sxxe'//'_il'//zchar1  ;   z3d(:,:,:) = sxxe(:,:,jk,:)   ;   CALL iom_rstput( iter, nitrst, numriw, znam , z3d )
+            znam = 'syye'//'_il'//zchar1  ;   z3d(:,:,:) = syye(:,:,jk,:)   ;   CALL iom_rstput( iter, nitrst, numriw, znam , z3d )
+            znam = 'sxye'//'_il'//zchar1  ;   z3d(:,:,:) = sxye(:,:,jk,:)   ;   CALL iom_rstput( iter, nitrst, numriw, znam , z3d )
+         END DO
+         !
+         IF( ln_pnd_H12 ) THEN                                       ! melt pond fraction
+            CALL iom_rstput( iter, nitrst, numriw, 'sxap' , sxap  )
+            CALL iom_rstput( iter, nitrst, numriw, 'syap' , syap  )
+            CALL iom_rstput( iter, nitrst, numriw, 'sxxap', sxxap )
+            CALL iom_rstput( iter, nitrst, numriw, 'syyap', syyap )
+            CALL iom_rstput( iter, nitrst, numriw, 'sxyap', sxyap )
+            !                                                        ! melt pond volume
+            CALL iom_rstput( iter, nitrst, numriw, 'sxvp' , sxvp  )
+            CALL iom_rstput( iter, nitrst, numriw, 'syvp' , syvp  )
+            CALL iom_rstput( iter, nitrst, numriw, 'sxxvp', sxxvp )
+            CALL iom_rstput( iter, nitrst, numriw, 'syyvp', syyvp )
+            CALL iom_rstput( iter, nitrst, numriw, 'sxyvp', sxyvp )
          ENDIF
          !
